SystemOrganization addCategory: #ConfigurationOfKomHttpServer!

Object subclass: #ConfigurationOfKomHttpServer
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKomHttpServer'!

!ConfigurationOfKomHttpServer class methodsFor: 'development support' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfKomHttpServer class methodsFor: 'private' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfKomHttpServer class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 12/29/2013 18:13'!
catalogChangeLog
		
 ^ '- Version 1.0 migrated to SmalltalkHub
[[[
(ConfigurationOfKomHttpServer project version: ''1.0'') load
]]]
'! !

!ConfigurationOfKomHttpServer class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 12/29/2013 18:14'!
catalogContactInfo
	^ 'Authors: 	Bolot Kerimbaev, Stephen Pair.
Maintainers: Gran Krampe, Giovanni Corriga, Julian Fitzell, Francois Stephany, Micheal Rueger, Damien Cassou, Hernn Morales Durand.
	
Maintainer e-mail: hernan.morales@gmail.com'! !

!ConfigurationOfKomHttpServer class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 12/29/2013 18:11'!
catalogDescription

	^ 'Kom, KomHttpServer or Comanche is a HTTP Server for Smalltalk'! !

!ConfigurationOfKomHttpServer class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 12/29/2013 18:16'!
catalogKeyClassesAndExample

	^ ' To get a simple web server running, install this package and evaluate the code below. A simple file serving web server will be started and will serve the files in your default directory:

[[[ 
	| ma |
	ma := ModuleAssembly core.
	ma serverRoot: FileSystem workingDirectory fullName.
	ma documentRoot: FileSystem workingDirectory fullName.
	ma directoryIndex: ''index.html index.htm''.
	ma serveFiles.
	(HttpService startOn: 8080 named: ''httpd'') plug: ma rootModule
]]]
'! !

!ConfigurationOfKomHttpServer class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 12/29/2013 19:43'!
catalogKeywords
	^ #(web server comanche komhttpserver kom http)! !

!ConfigurationOfKomHttpServer class methodsFor: 'private' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfKomHttpServer class methodsFor: 'private' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfKomHttpServer class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKomHttpServer class methodsFor: 'loading' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfKomHttpServer class methodsFor: 'loading' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfKomHttpServer class methodsFor: 'loading' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfKomHttpServer class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
project

	^self new project! !

!ConfigurationOfKomHttpServer class methodsFor: 'development support' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfKomHttpServer methodsFor: 'baselines' stamp: 'HernanMoralesDurand 1/9/2014 20:06'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/KomHttpServer/main'.
		spec project: 'Grease' with: [ 
			spec
				className: 'ConfigurationOfGrease';
				file: 'ConfigurationOfGrease';
				version: #stable;
				repository: 'http://www.smalltalkhub.com/mc/hernan/Grease/main' ].
		spec 
			package: 'DynamicBindings';
			package: 'KomServices';
			package: 'KomHttpServer' with: [ spec requires: #('Grease') ].
		spec group: 'default' with: #( 'DynamicBindings' 'KomServices' 'KomHttpServer')  ].! !

!ConfigurationOfKomHttpServer methodsFor: 'baselines' stamp: 'HernanMoralesDurand 1/9/2014 20:06'!
baseline11: spec
	" When Grease be ready to load out of the Seaside-box, this baseline should be used "

	<version: '1.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/KomHttpServer/main'.
		spec project: 'Grease' with: [ 
			spec
				className: 'ConfigurationOfGrease';
				loads: #('Tests');
				file: 'ConfigurationOfGrease';
				version: #stable;
				repository: 'http://www.smalltalkhub.com/mc/Seaside/Grease11/main' ].
		spec 
			package: 'DynamicBindings';
			package: 'KomServices';
			package: 'KomHttpServer' with: [ spec requires: #('Grease') ].
		spec group: 'default' with: #( 'DynamicBindings' 'KomServices' 'KomHttpServer')  ].! !

!ConfigurationOfKomHttpServer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfKomHttpServer methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 1/9/2014 20:07'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfKomHttpServer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/22/2013 01:20'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfKomHttpServer methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 12/29/2013 19:57'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
	spec for: #'pharo2.x' version: '1.0'.
	spec for: #'pharo3.x' version: '1.0'.! !

!ConfigurationOfKomHttpServer methodsFor: 'versions' stamp: 'HernanMoralesDurand 12/31/2013 05:25'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'The Comanche HTTP Server
First release for Pharo >= 2.0'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '10/22/2013 01:42'.
		spec 
			package: 'DynamicBindings' with: 'DynamicBindings-HernanMoralesDurand.14';
			package: 'KomServices' with: 'KomServices-lr.21' ].
	
	spec for: #'pharo2.x' do: [ 
		spec package: 'KomHttpServer' with: 'KomHttpServer-HernanMoralesDurand.73'. ].

	spec for: #'pharo3.x' do: [	
		spec package: 'KomHttpServer' with: 'KomHttpServer-HernanMoralesDurand.76' ].! !
